aboutsummaryrefslogtreecommitdiffstats
diff options
context:
space:
mode:
authorFilipe Manana <fdmanana@suse.com>2017-01-12 03:13:37 +0000
committerEryu Guan <eguan@redhat.com>2017-01-20 20:05:56 +0800
commit7cf665d9a42285ae177501eb7906f1fd0f772616 (patch)
treefeeca9667d0b69ca9c49f3e997e897d538c7e0a7
parent6fc65f42eb9b1c32d156f78127e5ab702695d80a (diff)
downloadxfstests-dev-7cf665d9a42285ae177501eb7906f1fd0f772616.tar.gz
btrfs: incremental send after moving a directory
Test that an incremental send operation works after moving a directory into a new parent directory, deleting its previous parent directory and creating a new inode that has the same inode number as the old parent. This issue is fixed by the following patch for the linux kernel: "Btrfs: incremental send, do not delay rename when parent inode is new" Signed-off-by: Robbie Ko <robbieko@synology.com> Signed-off-by: Filipe Manana <fdmanana@suse.com> Reviewed-by: Eryu Guan <eguan@redhat.com> Signed-off-by: Eryu Guan <eguan@redhat.com>
-rwxr-xr-xtests/btrfs/134125
-rw-r--r--tests/btrfs/134.out6
-rw-r--r--tests/btrfs/group1
3 files changed, 132 insertions, 0 deletions
diff --git a/tests/btrfs/134 b/tests/btrfs/134
new file mode 100755
index 0000000000..8224e47750
--- /dev/null
+++ b/tests/btrfs/134
@@ -0,0 +1,125 @@
+#! /bin/bash
+# FS QA Test No. btrfs/134
+#
+# Test that an incremental send operation works after moving a directory into
+# a new parent directory, deleting its previous parent directory and creating
+# a new inode that has the same inode number as the old parent.
+#
+#-----------------------------------------------------------------------
+# Copyright (C) 2017 Synology Inc. All Rights Reserved.
+# Author: Robbie Ko <robbieko@synology.com>
+#
+# This program is free software; you can redistribute it and/or
+# modify it under the terms of the GNU General Public License as
+# published by the Free Software Foundation.
+#
+# This program is distributed in the hope that it would be useful,
+# but WITHOUT ANY WARRANTY; without even the implied warranty of
+# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
+# GNU General Public License for more details.
+#
+# You should have received a copy of the GNU General Public License
+# along with this program; if not, write the Free Software Foundation,
+# Inc., 51 Franklin St, Fifth Floor, Boston, MA 02110-1301 USA
+#-----------------------------------------------------------------------
+#
+
+seq=`basename $0`
+seqres=$RESULT_DIR/$seq
+echo "QA output created by $seq"
+
+tmp=/tmp/$$
+status=1 # failure is the default!
+trap "_cleanup; exit \$status" 0 1 2 3 15
+
+_cleanup()
+{
+ cd /
+ rm -fr $send_files_dir
+ rm -f $tmp.*
+}
+
+# get standard environment, filters and checks
+. ./common/rc
+. ./common/filter
+
+# real QA test starts here
+_supported_fs btrfs
+_supported_os Linux
+_require_test
+_require_scratch
+_require_fssum
+
+send_files_dir=$TEST_DIR/btrfs-test-$seq
+
+rm -f $seqres.full
+rm -fr $send_files_dir
+mkdir $send_files_dir
+
+_scratch_mkfs >>$seqres.full 2>&1
+_scratch_mount
+
+mkdir $SCRATCH_MNT/dir257
+mkdir $SCRATCH_MNT/dir258
+mkdir $SCRATCH_MNT/dir259
+mv $SCRATCH_MNT/dir257 $SCRATCH_MNT/dir258/dir257
+
+# Filesystem looks like:
+#
+# . (ino 256, gen 3)
+# |--- dir258/ (ino 258, gen 7)
+# | |--- dir257/ (ino 257, gen 7)
+# |
+# |--- dir259/ (ino 259, gen 7)
+#
+$BTRFS_UTIL_PROG subvolume snapshot -r $SCRATCH_MNT \
+ $SCRATCH_MNT/mysnap1 > /dev/null
+
+mv $SCRATCH_MNT/dir258/dir257 $SCRATCH_MNT/dir257
+rmdir $SCRATCH_MNT/dir258
+rmdir $SCRATCH_MNT/dir259
+# Remount the filesystem so that the next created inodes will have the numbers
+# 258 and 259. This is because when a filesystem is mounted, btrfs sets the
+# subvolume's inode counter to a value corresponding to the highest inode number
+# in the subvolume plus 1. This inode counter is used to assign a unique number
+# to each new inode and it's incremented by 1 after very inode creation.
+# Note: we unmount and then mount instead of doing a mount with "-o remount"
+# because otherwise the inode counter remains at value 260.
+_scratch_cycle_mount
+touch $SCRATCH_MNT/file258
+mkdir $SCRATCH_MNT/new_dir259
+mv $SCRATCH_MNT/dir257 $SCRATCH_MNT/new_dir259/dir257
+
+# Filesystem now looks like:
+#
+# . (ino 256, gen 3)
+# |--- file258 (ino 258, gen 10)
+# |
+# |--- new_dir259/ (ino 259, gen 10)
+# |--- dir257/ (ino 257, gen 7)
+#
+$BTRFS_UTIL_PROG subvolume snapshot -r $SCRATCH_MNT \
+ $SCRATCH_MNT/mysnap2 > /dev/null
+
+$FSSUM_PROG -A -f -w $send_files_dir/1.fssum $SCRATCH_MNT/mysnap1
+$FSSUM_PROG -A -f -w $send_files_dir/2.fssum \
+ -x $SCRATCH_MNT/mysnap2/mysnap1 $SCRATCH_MNT/mysnap2
+
+$BTRFS_UTIL_PROG send $SCRATCH_MNT/mysnap1 -f \
+ $send_files_dir/1.snap 2>&1 1>/dev/null | _filter_scratch
+$BTRFS_UTIL_PROG send -p $SCRATCH_MNT/mysnap1 $SCRATCH_MNT/mysnap2 \
+ -f $send_files_dir/2.snap 2>&1 1>/dev/null | _filter_scratch
+
+# Now recreate the filesystem by receiving both send streams and verify we get
+# the same content that the original filesystem had.
+_scratch_unmount
+_scratch_mkfs >>$seqres.full 2>&1
+_scratch_mount
+
+$BTRFS_UTIL_PROG receive $SCRATCH_MNT -f $send_files_dir/1.snap > /dev/null
+$FSSUM_PROG -r $send_files_dir/1.fssum $SCRATCH_MNT/mysnap1
+$BTRFS_UTIL_PROG receive $SCRATCH_MNT -f $send_files_dir/2.snap > /dev/null
+$FSSUM_PROG -r $send_files_dir/2.fssum $SCRATCH_MNT/mysnap2
+
+status=0
+exit
diff --git a/tests/btrfs/134.out b/tests/btrfs/134.out
new file mode 100644
index 0000000000..75b30a1270
--- /dev/null
+++ b/tests/btrfs/134.out
@@ -0,0 +1,6 @@
+QA output created by 134
+At subvol SCRATCH_MNT/mysnap1
+At subvol SCRATCH_MNT/mysnap2
+At subvol mysnap1
+OK
+OK
diff --git a/tests/btrfs/group b/tests/btrfs/group
index 0cdd413698..f33befb359 100644
--- a/tests/btrfs/group
+++ b/tests/btrfs/group
@@ -135,3 +135,4 @@
131 auto quick
132 auto enospc
133 auto quick send
+134 auto quick send